Label Switched Path (LSP) Object Flag Extension of Stateful PCE
Internet-Draft draft-ietf-pce-lsp-extended-flags-04
Quan Xiong
ZTE Corporation
No.6 Huashi Park Rd
Wuhan
Hubei
430223
China
xiong.quan@zte.com.cn
Routing
PCE
PCEP
RFC 8231 describes a set of extensions to Path Computation Element Communication Protocol (PCEP) to enable stateful control of MPLS-TE and GMPLS Label Switched Paths (LSPs) via PCEP. One of the extensions is the LSP object which includes a Flag field of the length of 12 bits. However, all bits of the Flag field have already been assigned in RFC 8231, RFC 8281, RFC 8623 and I-D.ietf-pce-binding-label-sid.
[Note to RFC Editor - Replace I-D.ietf-pce-binding-label-sid to RFC XXXX, once the RFC number is assigned.]
This document proposes to define a new LSP-EXTENDED-FLAG TLV for the LSP object for an extended flag field.
Introduction
[RFC5440] describes the Path Computation Element (PCE) Communication Protocol (PCEP) which is used between a PCE and a Path Computation Client (PCC) (or other PCE) to enable computation of Multi-protocol Label Switching (MPLS) for Traffic Engineering Label Switched Path (TE LSP).
PCEP Extensions for the Stateful PCE Model [RFC8231] describes a set of extensions to PCEP to enable active control of MPLS-TE and Generalized MPLS (GMPLS) tunnels. One of the extensions is the LSP object which contains a flag field; bits in the flag field are used to indicate delegation, synchronization, removal, etc.
As defined in [RFC8231], the length of the flag field is 12 bits and the value from bit 5 to bit 11 is used for operational, administrative, remove, synchronize and delegate bits respectively. The bit value 4 is assigned in [RFC8281] for create for PCE-Initiated LSPs. The bits from 1 to 3 is assigned in [RFC8623] for Explicit Route Object (ERO)-compression, fragmentation and Point-to-Multipoint (P2MP) respectively. The bit 0 is assigned in [I-D.ietf-pce-binding-label-sid] to PCE-allocation. All bits of the Flag field has been assigned already. Thus, it is required to extend the flag field for the LSP Object for future use.
This document proposes to define a new LSP-EXTENDED-FLAG TLV for an extended flag field in the LSP object.
Conventions used in this document
Terminology
The terminology is defined as [RFC5440] and [RFC8231].
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
PCEP Extension
The LSP Object is defined in Section 7.3 of [RFC8231]. This document proposes to define a new LSP-EXTENDED-FLAG TLV for an extended flag field in the LSP object.
The LSP-EXTENDED-FLAG TLV
The format of the LSP-EXTENDED-FLAG TLV follows the format of all PCEP TLVs as defined in [RFC5440] and is shown in the Figure 1.
Figure 1: LSP-EXTENDED-FLAG TLV Format

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|           Type=TBD1           |           Length              |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
//                 LSP Extended Flags                          //
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type (16 bits): the value is TBD1 by IANA.
Length (16 bits): multiple of 4 octets.
LSP Extended Flags: this contains an array of units of 32-bit flags numbered from the most significant as bit zero, where each bit represents one LSP flag (for operation, feature, or state). Currently no bits are assigned. Unassigned bits MUST be set to zero on transmission and MUST be ignored on receipt.
As an example of usage of the LSP-EXTENDED-FLAG TLV, the E-flag is requested for entropy label configuration as proposed in [I-D.peng-pce-entropy-label-position].
Processing
The LSP Extended Flags field is an array of units of 32 flags and to be allocated starting from the most significant bit. The bits of the LSP Extended Flags field will be assigned by future documents. This document does not define any flags. Unassigned flags MUST be set to zero on transmission and MUST be ignored on receipt. Implementations that do not understand any particular flag MUST ignore the flag. This flags should follow the specification as per [RFC8786].
Note that, PCEP peers MAY encounter different length of the LSP-EXTENDED-FLAG TLV.
If a PCEP speaker receives the LSP-EXTENDED-FLAG TLV of a length more than it currently supports or understands, it will simply ignore the bits beyond that length.
If a PCEP speaker receives the LSP-EXTENDED-FLAG TLV of a length less than the one supported by the implementation, it will consider the bits beyond the length to be unset.
Backward Compatibility
The LSP-EXTENDED-FLAG TLV defined in this document does not introduce any interoperability issues.
A router that does not understand or support the LSP-EXTENDED-FLAG TLV will silently ignore the TLV as per [RFC5440]. It is expected that future document that define bits in the LSP-EXTENDED-FLAG TLV would also define the error case handling required for missing LSP-EXTENDED-FLAG TLV if it MUST be present.
IANA Considerations
LSP Object
PCEP TLV Type Indicators
IANA is requested to allocate the following TLV Type Indicator value within the "PCEP TLV Type Indicators" subregistry of the "Path Computation Element Protocol (PCEP) Numbers" registry:
Value | Description | Reference
TBD1 | LSP-EXTENDED-FLAG | [This document]
LSP Extended Flags Field
IANA is requested to create a new subregistry called "LSP-EXTENDED-FLAG TLV Flag Field", within the "Path Computation Element Protocol (PCEP) Numbers" registry to manage the LSP Extended Flags field of the LSP-EXTENDED-FLAG TLV. New values are assigned by Standards Action [RFC8126]. Each bit should be tracked with the following qualities:
- Bit number (counting from bit 0 as the most significant bit)
- Capability description
- Defining RFC
No values are currently defined.
Implementation Status
[NOTE TO RFC EDITOR : This whole section and the reference to [RFC7942] is to be removed before publication as an RFC]
This section records the status of known implementations of the protocol defined by this specification at the time of posting of this Internet-Draft, and is based on a proposal described in [RFC7942]. The description of implementations in this section is intended to assist the IETF in its decision processes in progressing drafts to RFCs. Please note that the listing of any individual implementation here does not imply endorsement by the IETF. Furthermore, no effort has been spent to verify the information presented here that was supplied by IETF contributors. This is not intended as, and must not be construed to be, a catalog of available implementations or their features. Readers are advised to note that other implementations may exist.
According to [RFC7942], "this will allow reviewers and working groups to assign due consideration to documents that have the benefit of running code, which may serve as evidence of valuable experimentation and feedback that have made the implemented protocols more mature. It is up to the individual working groups to use this information as they see fit".
At the time of posting this version of this document, there are no known implementations of this TLV. It is believed that this would be implemented along side the documents that allocate flags in the TLV.
Management Considerations
Implementations receiving set LSP Extended Flags that they do not recognize MAY log this. That could be helpful for diagnosing backward compatibility issues with future features that utilize those flags.
Security Considerations
[RFC8231] sets out security considerations for PCEP when used for communication with a stateful PCE. This document does not change those considerations. For LSP Object processing, see [RFC8231].
This document provides for future extension of PCEP. No additional security issues are raised in this document beyond those that exist in the referenced documents.
Acknowledgements
The authors would like to thank Loa Andersson, Adrian Farrel, Aijun Wang, and Gyan Mishra for their review, suggestions and comments to this document.
Contributors
The following people have substantially contributed to this document:

	Dhruv Dhody
	Huawei Technologies
	EMail: dhruv.ietf@gmail.com

	Greg Mirsky
	Ericsson
	Email: gregimirsky@gmail.com

References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC5440]

Path Computation Element (PCE) Communication Protocol (PCEP)
JP. Vasseur, Ed.
JL. Le Roux, Ed.
March 2009
RFC 5440
DOI 10.17487/RFC5440
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8231]

Path Computation Element Communication Protocol (PCEP) Extensions for Stateful PCE
E. Crabbe
I. Minei
J. Medved
R. Varga
September 2017
RFC 8231
DOI 10.17487/RFC8231
[RFC8126]

Guidelines for Writing an IANA Considerations Section in RFCs
M. Cotton
B. Leiba
T. Narten
June 2017
BCP 26
RFC 8126
DOI 10.17487/RFC8126
[RFC8786]

Updated Rules for Processing Stateful PCE Request Parameters Flags
A. Farrel
May 2020
RFC 8786
DOI 10.17487/RFC8786
Informative References
[RFC5088]

OSPF Protocol Extensions for Path Computation Element (PCE) Discovery
JL. Le Roux, Ed.
JP. Vasseur, Ed.
Y. Ikejiri
R. Zhang
January 2008
RFC 5088
DOI 10.17487/RFC5088
[RFC5089]

IS-IS Protocol Extensions for Path Computation Element (PCE) Discovery
JL. Le Roux, Ed.
JP. Vasseur, Ed.
Y. Ikejiri
R. Zhang
January 2008
RFC 5089
DOI 10.17487/RFC5089
[RFC7942]

Improving Awareness of Running Code: The Implementation Status Section
Y. Sheffer
A. Farrel
July 2016
BCP 205
RFC 7942
DOI 10.17487/RFC7942
[RFC8281]

Path Computation Element Communication Protocol (PCEP) Extensions for PCE-Initiated LSP Setup in a Stateful PCE Model
E. Crabbe
I. Minei
S. Sivabalan
R. Varga
December 2017
RFC 8281
DOI 10.17487/RFC8281
[RFC8623]

Stateful Path Computation Element (PCE) Protocol Extensions for Usage with Point-to-Multipoint TE Label Switched Paths (LSPs)
U. Palle
D. Dhody
Y. Tanaka
V. Beeram
June 2019
RFC 8623
DOI 10.17487/RFC8623
[I-D.ietf-pce-binding-label-sid]

Carrying Binding Label/Segment Identifier (SID) in PCE-based Networks.
Siva Sivabalan
Ciena Corporation
Clarence Filsfils
Cisco Systems, Inc.
Jeff Tantsura
Microsoft Corporation
Stefano Previdi
Huawei Technologies
Cheng Li (editor)
Huawei Technologies
20 March 2022
Internet-Draft draft-ietf-pce-binding-label-sid-15
[I-D.peng-pce-entropy-label-position]

PCEP Extension for SR-MPLS Entropy Label Position
Quan Xiong
ZTE Corporation
Shaofu Peng
ZTE Corporation
Fengwei Qin
China Mobile
29 August 2022
Internet-Draft draft-peng-pce-entropy-label-position-08
WG Discussion
The WG discussed the idea of a fixed length (with 32 bits) for LSP- EXTENDED-FLAG TLV. Though 32 bits would be sufficient for quite a while, the use of variable length with a multiple of 32-bits allows for future extensibility where we would never run out of flags and there would not be a need to define yet another TLV in the future. Further, note that [RFC5088] and [RFC5089] use the same approach for the PCE-CAP-FLAGS Sub-TLV and are found to be useful.